unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.ExtCtrls, Vcl.StdCtrls, System.Math,
  Vcl.Buttons;

Type
  TDIarray   = array of array of Double;

type
  TForm1 = class(TForm)
    FileOpenbtn: TButton;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    RGBtoHSVtoRGBBtn: TButton;
    Image2: TImage;
    sat_imageBtn: TButton;
    hue_imageBtn: TButton;
    YmEdit: TLabeledEdit;
    SmEdit: TLabeledEdit;
    HdEdit: TLabeledEdit;
    CheckBox1: TCheckBox;
    yTograyBtn: TButton;
    tran_yshBtn: TBitBtn;
    procedure FileOpenbtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RGBtoHSVtoRGBBtnClick(Sender: TObject);
    procedure sat_imageBtnClick(Sender: TObject);
    procedure hue_imageBtnClick(Sender: TObject);
    procedure tran_yshBtnClick(Sender: TObject);
    procedure yTograyBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure rgb_to_yc;                      // q,f,aPx,FMɕϊ
    procedure yc_to_rgb(y, c1, c2: TDIarray); // Px,FMq,f,aMɕϊ
    procedure c_to_sh;                        // FMʓx,FvZ
    procedure sh_to_c;                        // ʓx,FFMvZ
    function  sat_image: Integer;             // ʓxf[^ZW摜
    procedure hue_image;                      // Ff[^摜
    procedure tran_ysh(ym, sm, hd :Double);   // Px,ʓx,Fς
    procedure setarray;                       // zTCYݒ
  public
    { Public 錾 }
  end;

type
  TPrgbarry = array[0..0] of Trgbtriple;
  Prgbarry  = ^TPrgbarry;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHW   = 384;                            // \gTCY

//  kr = 0.299;                                 // R PxϊW
//  kg = 0.587;                                 // G PxϊW
//  kb = 0.114;                                 // B PxϊW


var
  GHeight, GWidth : integer;
  Vrect           : Trect;
  InBitmap        : TBitmap;
  OutBitmap       : TBitmap;
  Inprgbarry      : array of Prgbarry;
  y               : TDIarray;                 // y  Px
  c1              : TDIarray;                 // R - Y
  c2              : TDIarray;                 // B - y
  sat             : TDIarray;                 // ʓx
  hue             : TDIarray;                 // F

  Out_y           : TDIarray;                 // y  Px
  Out_sat         : TDIarray;                 // ʓx
  Out_Hue         : TDIarray;                 // F
  Out_c1          : TDIarray;                 // R - Y
  Out_c2          : TDIarray;                 // B - y

  kr              : double;                   // = 0.299;  R PxϊW
  kg              : double;                   // = 0.587;  G PxϊW
  kb              : double;                   // = 0.114;  B PxϊW

//--- tran_ysh  Px,ʓx,Fς܂ ---------------
//    y:            ̓f[^z@x
//    sat:          ̓f[^z@r`s
//    hue:          ̓f[^z@gtd
//    out_y:        o̓f[^z@x
//    out_sat:      o̓f[^z@r`s
//    out_hue:      o̓f[^z@gtd
//    ym:           Px̏搔
//    sm:           ʓx̏搔
//    hd:           F̑
//------------------------------------------------------
procedure TForm1.tran_ysh(ym, sm, hd :Double);
var
  i, j  : integer;
begin
  for i := 0 to GHeight - 1 do
    for j := 0 to GWidth - 1 do begin
      out_y[i][j]   := y[i][j] * ym;         // Px̌vZ
      out_sat[i][j] := sat[i][j] * sm;       // ʓx̌vZ
      out_hue[i][j] := hue[i][j] + hd;       // F̌vZ
      if out_hue[i][j] > 360 then out_hue[i][j] := out_hue[i][j] - 360;
      if out_hue[i][j] <  0  then out_hue[i][j] := out_hue[i][j] + 360;
    end;
  sh_to_c;                                            // ʓx,FFMvZ
  yc_to_rgb(out_Y, out_C1, out_C2);                   // Px,FMq,f,aMɕϊ
  Image2.Canvas.StretchDraw(VRect, OutBitmap);        // o͘gɕϔ{o
end;

//------------- PxAʓxAFς܂ -----------------
//    ym:           Px̏搔
//    sm:           ʓx̏搔
//    hd:           F̑
//--------------------------------------------------------
procedure TForm1.tran_yshBtnClick(Sender: TObject);
var
  ym    : Double;
  sm    : Double;
  hd    : Double;
  ch    : Integer;
begin
  if CheckBox1.Checked then begin
    // `FbN PxϊWFpx120xɂȂ悤ɐݒ R 105x g 225x b 345x
    // R105xɂ
    kr := 255 / (255 - 255 * tan(105 / 180 * pi));  // kr = kb = 0.211325
    kb := kr;
    kg := 1 - kr - kb;                              // kg = 0.57735
  end
  else begin
    // ʏ  R 113x  g 225x  b 353 x
    kr  := 0.299;                     // R PxϊW
    kg  := 0.587;                     // G PxϊW
    kb  := 0.114;                     // B PxϊW
  end;
  setarray;                           // zTCYݒ
  rgb_to_yc;                          // q,f,aPx,FMɕϊ
  c_to_sh;                            // FMʓx,FvZ
  val(ymEdit.Text, ym, ch);       // Px̏搔
  if ch <> 0 then ym := 1;
  ym := abs(ym);
  val(smEdit.Text, sm, ch);       // ʓx̏搔
  if ch <> 0 then sm := 1;
  sm := abs(sm);
  val(hdEdit.Text, hd, ch);       // F̑
  if ch <> 0 then hd := 0;
  if hd > 360  then hd :=  360;   // 360xȓɐݒ
  if hd < -360 then hd := -360;
  tran_ysh(ym, sm, hd);           // Px,ʓx,Fς
end;

//--- hue_image  Ff[^摜܂ ---------------------
//    sat:          ʓx̃f[^z
//    hue:          F̃f[^z
//    stdhue:       ƂȂFl
//    OutBitmap:    o͉摜
//-------------------------------------------------------------
procedure TForm1.hue_image;
var
  i, j    : Integer;
  ihue    : Integer;
  delt    : Double;
  OutPrgbarray  : Prgbarry;
  stdhue  : double;
begin
  val(hdedit.Text, stdhue, i);
  if i <> 0 then stdhue := 0;
  if stdhue > 360  then stdhue :=  360;                       // 360xȓɐݒ
  if stdhue < -360 then stdhue := -360;
  for i := 0 to GHeight - 1 do begin
    OutPrgbarray := OutBitmap.ScanLine[i];
    for j := 0 to GWidth -1 do begin
      if sat[i][j] > 0 then begin                             // ʓx[ȏゾ
        delt := abs(hue[i][j] - stdhue);                      // Fpx̐Βl
        if delt < 0 then delt := delt + 360;
        if delt > 180  then delt := 360.0 - delt;             // 180xȓɐݒ@
        ihue := Trunc(255.0 - delt * 255.0 / 180);            // 2550ɕϊ
        OutPrgbarray[j].rgbtBlue  := ihue;
        OutPrgbarray[j].rgbtGreen := ihue;
        OutPrgbarray[j].rgbtRed   := ihue;
      end
      else begin
        OutPrgbarray[j].rgbtBlue  := 0;
        OutPrgbarray[j].rgbtGreen := 0;
        OutPrgbarray[j].rgbtRed   := 0;
      end;
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

procedure TForm1.hue_imageBtnClick(Sender: TObject);
begin
  hue_image;        // Ff[^摜
end;

//--- sat_image  ʓxf[^ZW摜܂ ----------------------------
//    sat:          ʓx̃f[^z
//    OutBitmap:    o͉摜
//------------------------------------------------------------------------
function TForm1.sat_image: Integer;
var
  i, j      : Integer;
  isat      : Integer;
  min, max  : double;
  OutPrgbarray  : Prgbarry;
begin
  min := 255;
  max := 0;
  // ʓx̍őlƍŏl
  for i := 0 to  GHeight - 1 do
    for j := 0 to GWidth - 1 do begin
      if sat[i][j] > max then max := sat[i][j];
      if sat[i][j] < min then min := sat[i][j];
    end;
  // ʓxȂI
  if min = max then begin
    result := -1;
    exit;
  end;
  for i := 0 to GHeight - 1 do begin
    OutPrgbarray := OutBitmap.ScanLine[i];
    for j := 0 to GWidth - 1 do begin
      isat := Trunc(255 * (sat[i][j] - min) / (max - min));   // ʓx̒l0`255ɕϊ
      OutPrgbarray[j].rgbtRed   := isat;
      OutPrgbarray[j].rgbtGreen := isat;
      OutPrgbarray[j].rgbtBlue  := isat;
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
  result := 0;
end;

procedure TForm1.sat_imageBtnClick(Sender: TObject);
var
  Ret : Integer;
begin
  Ret := sat_image;                                           // ʓxf[^ZW摜
  if Ret = -1 then application.MessageBox('ʓx܂B','',0);
end;

//--- sh_to_c  ʓx,FFMvZ܂ -----------------------------
//    out_c1:     o̓f[^zq|x
//    out_c2:     o̓f[^za|x
//    out_sat:    ʓx̃f[^z
//    out_hue:    F̃f[^z
//----------------------------------------------------------------------------
procedure TForm1.sh_to_c;
var
  i, j  : Integer;
  rad   : Double;
begin
  for i := 0 to GHeight - 1 do
    for j := 0 to GWidth do begin
      rad := PI * out_hue[i][j] / 180;
      out_c1[i][j] := out_sat[i][j] * sin(rad);
      out_c2[i][j] := out_sat[i][j] * cos(rad);
    end;
end;

//---- c_to_sh  FMʓx,FvZ܂ ----------------------------
//    c1:        ̓f[^zq|x
//    c2:        ̓f[^za|x
//    sat:      ʓx̃f[^z
//    hue:      F̃f[^z
//    PFpx    R 113x@g 225x@b 353x  ʏ͋ϓ̊pxɂ͂ȂĂȂ
//    ϓz  R 105x  g 225x  b 345x  CheckBox check
//----------------------------------------------------------------------------
procedure TForm1.c_to_sh;
const
  THRESHOLD =  0;               // ʓx̗L𔻒f臒l
  NONE      =  0;               // ʓxȂꍇɑl
var
  i, j          : Integer;
  fhue, length  : Double;
begin
  for i := 0 to  GHeight -1 do
    for j := 0 to GWidth - 1 do begin
      length    := c1[i][j] * c1[i][j] + c2[i][j] * c2[i][j];
      sat[i][j] := sqrt(length);                              // ʓx
      if sat[i][j] > THRESHOLD then begin
        fhue := arctan2(c1[i][j] , c2[i][j]) * 180 / pi;      // F
        if fhue < 0 then  fhue := fhue + 360;
        hue[i][j] := fhue;
      end
      else hue[i][j] := NONE;  // ʓx臒lȉ̎
    end;
end;

//--- yc_to_rgb  Px,FMq,f,aMɕϊ܂ --------------------
//    y:            ̓f[^z@x
//    c1:           ̓f[^zq|x
//    c2:           ̓f[^za|x
//    OutBitmap:     o͉摜
//  fr         =  y[i][j] + c1[i][j]
//  fb         =  y[i][j] + c2[i][j]
//  y[i][j]    =  0.299 * fr + 0.587 * fg + 0.114 * fb
//  0.587 * fg =  y[i][j] - 0.299 * fr - 0.114 * fb
//  fg         = (y[i][j] - 0.299 * fr - 0.114 * fb) / 0.587
//  fg         =  y[i][j] - 0.299 / 0.587 * c1[i][j] - 0.114 / 0.587 * c2[i][j]
//------------------------------------------------------------------------------
procedure TForm1.yc_to_rgb(y, c1, c2: TDIarray);
var
  i, j          : Integer;
  ir, ig, ib    : Integer;
  OutPrgbarray  : Prgbarry;
  a, b          : Double;
begin
  a := kr / kg;                                            // a = 0.299 / 0.587
  b := kb / kg;                                            // b = 0.114 / 0.587
  for i := 0 to GHeight - 1 do begin
    OutPrgbarray := OutBitmap.ScanLine[i];
    for j := 0 to GWidth - 1 do begin
      ir := Trunc(y[i][j] + c1[i][j]);                     // R = Y + (R - y)
      if ir > 255 then ir := 255;
      if ir < 0   then ir := 0;
      ig := Trunc(y[i][j] - a * c1[i][j] - b * c2[i][j]);  // G = Y - a(R - Y) - b(B - Y);
      if ig > 255 then ig := 255;
      if ig < 0   then ig := 0;
      ib := Trunc(y[i][j] + c2[i][j]);                     // B = Y + (B - Y)
      if ib > 255 then ib := 255;
      if ib < 0   then ib := 0;
      OutPrgbarray[j].rgbtRed   := ir;
      OutPrgbarray[j].rgbtGreen := ig;
      OutPrgbarray[j].rgbtBlue  := ib;
    end;
  end;
end;

// OC摜(Px)\
procedure TForm1.yTograyBtnClick(Sender: TObject);
var
  i, j          : Integer;
  iglay         : Integer;
  OutPrgbarray  : Prgbarry;
begin
  for i := 0 to GHeight - 1 do begin
    OutPrgbarray := OutBitmap.ScanLine[i];
    for j := 0 to GWidth - 1 do begin
      iglay := round(y[i,j]);
      OutPrgbarray[j].rgbtRed   := iglay;
      OutPrgbarray[j].rgbtGreen := iglay;
      OutPrgbarray[j].rgbtBlue  := iglay;
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

//--- rgb_to_yc  q,f,aPx,FMɕϊ܂ ------------------------
//    Inprgbarry:    ͉摜z
//    y:             o̓f[^z@x
//    c1:            o̓f[^zq|x
//    c2:            o̓f[^za|x
//    y[i][j]  :=  0.299 * fr + 0.587 * fg + 0.114 * fb;      // Y
//    c1[i][j] :=  0.701 * fr - 0.587 * fg - 0.114 * fb;      // R - Y  (fr - y)
//    c2[i][j] := -0.299 * fr - 0.587 * fg + 0.886 * fb;      // B - Y  (fb - y)
//-----------------------------------------------------------------------------
procedure TForm1.rgb_to_yc;
var
  i, j        : Integer;
  fr, fg, fb  : Double;
begin
  for i := 0 to GHeight - 1 do
    for j := 0 to GWidth - 1 do begin
      fr := Inprgbarry[i][j].rgbtRed;
      fg := Inprgbarry[i][j].rgbtGreen;
      fb := Inprgbarry[i][j].rgbtBlue;
//      fr := 0;
//      fg := 0;
//      fb := 255;
      y[i][j]  :=  kr * fr + kg * fg + kb * fb;               // Y
      c1[i][j] :=  fr - y[i][j];                              // R - Y  (fr - y)
      c2[i][j] :=  fb - y[i][j];                              // B - Y  (fb - y)
   end;
end;

//---------- z̒Zbg---------------------
//    y:            f[^z@x
//    c1:           f[^zq|x
//    c2:           f[^za|x
//    sat:          ʓx̃f[^z
//    hue:          F̃f[^z
//    out_c1:       o̓f[^zq|x
//    out_c2:       o̓f[^za|x
//    out_sat:      o͍ʓx̃f[^z
//    out_hue:      o͐F̃f[^z
//    Inprgbarry:   ͉摜z
//------------------------------------------------
procedure TForm1.setarray;
var
  i        : integer;
begin
  setlength(Inprgbarry, GHeight);
  setlength(y,   GHeight, GWidth);
  setlength(C1,  GHeight, GWidth);
  setlength(C2,  GHeight, GWidth);
  setlength(sat, GHeight, GWidth);
  setlength(hue, GHeight, GWidth);
  setlength(out_sat, GHeight, GWidth);
  setlength(out_hue, GHeight, GWidth);
  setlength(out_y,   GHeight, GWidth);
  setlength(out_C1,  GHeight, GWidth);
  setlength(out_C2,  GHeight, GWidth);
  for i := 0 to GHeight - 1 do
    Inprgbarry[i] := InBitmap.ScanLine[i];
  OutBitmap.Width  := GWidth;
  OutBitmap.Height := GHeight;
end;

//------- eϊ㌳֖߂ĉ摜\mF--------------------
procedure TForm1.RGBtoHSVtoRGBBtnClick(Sender: TObject);
begin
  if CheckBox1.Checked then begin
    // `FbN PxϊWFpx120xɂȂ悤ɐݒ R 105x g 225x b 345x
    // R105xɂ
    kr := 255 / (255 - 255 * tan(105 / 180 * pi));  // kr = kb = 0.211325
    kb := kr;
    kg := 1 - kr - kb;                              // kg = 0.57735
  end
  else begin
    // ʏ  R 113x  g 225x  b 353 x
    kr  := 0.299;                     // R PxϊW
    kg  := 0.587;                     // G PxϊW
    kb  := 0.114;                     // B PxϊW
  end;
  setarray;                           // zTCYݒ
  rgb_to_yc;                          // q,f,aPx,FMɕϊ
  c_to_sh;                            // FMʓx,FvZ
  yc_to_rgb(Y, C1, C2);               // Px,FMq,f,aMɕϊ
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
  sat_imageBtn.Enabled  := True;
  hue_imageBtn.Enabled  := True;
  yTograyBtn.Enabled    := True;
end;

//------- 摜t@CI[v \---------------------------
procedure TForm1.FileOpenbtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
  IHeight     : Integer;
  IWidth      : Integer;
begin
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  Image2.Canvas.Brush.Style := bsSolid;
  Image2.Canvas.Brush.Color := clBtnface;
  Image2.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        IWidth  := ImageHW;                                   // o͐C[W1̕
        IHeight := ImageHW;                                   // o͐C[W1̍
        if GHeight <= GWidth then                             // cɂo̓TCYݒ
          IHeight := Round(IWidth * GHeight / GWidth)
        else
          IWidth := Round(IHeight * GWidth / GHeight);
        Image1.Width := IWidth;
        Image1.Height:= IHeight;
        Image1.Picture.Bitmap.SetSize(IWidth, IHeight);
        VRect := Rect(0, 0, IWidth, IHeight);                 // o͘gݒ
        Image1.Canvas.StretchDraw(VRect, WIC);                // o͘gɕϔ{o
        InBitmap.Width  := GWidth;
        InBitmap.Height := GHeight;
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  RGBtoHSVtoRGBBtn.Enabled    := True;
  sat_imageBtn.Enabled  := False;
  hue_imageBtn.Enabled  := False;
  tran_yshBtn.Enabled   := True;
end;

//----------- ݒ ------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Width  := ImageHW;
  Image1.Height := ImageHW;
  Image2.Width  := ImageHW;
  Image2.Height := ImageHW;
  InBitmap  := TBitmap.Create;
  OutBitmap := TBitmap.Create;
  InBitmap.PixelFormat  := pf24bit;
  OutBitmap.PixelFormat := pf24bit;
  RGBtoHSVtoRGBBtn.Enabled    := False;
  sat_imageBtn.Enabled  := False;
  hue_imageBtn.Enabled  := False;
  tran_yshBtn.Enabled   := False;
  yTograyBtn.Enabled    := False;
  tran_yshBtn.Caption := 'Color' + #13#10 + 'HSV to RGB';
end;

//------------ I ------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
end;

end.
