unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, system.Math;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    RedEdit: TLabeledEdit;
    GreenEdit: TLabeledEdit;
    BlueEdit: TLabeledEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    procedure hue_circle(Mode: integer);
    procedure color_bar(Mode: integer);
    procedure color_barout(Mode, r, g, b, pich, dtop: integer; fColor: TColor);
    procedure MonoColor_bar(Mode: integer);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.hue_circle(Mode: integer);
const
  q1 = 15;
  q2 = q1 / 2 - 2;
  q1p = q1 / 180 * pi;
  q2p = q2 / 180 * pi;
var
  i  : integer;
  hu : double;
  st : double;
  y, cb, cr     : double;
  fr, fg, fb    : double;
  kr, kg, kb    : double;
  kbg, krg      : double;
  r, g, b       : byte;
  max, min, ks  : double;
  VRect         : Trect;
  N             : integer;
begin
  // ϊWݒ
  if Mode = 0 then begin
    // WPxϊW@
    kr := 0.299;
    kg := 0.587;
    kb := 0.114;
  end
  else begin
    // 120FpxϊW
    kr := 0.211325;
    kg := 0.57735;
    kb := 0.211325;
  end;
  // tϊWvZ
  kbg := kb / kg;
  krg := kr / kg;
  // ʓxl
  st := 255;
  // Pxl
  y := 255;
  // vZ
  N := 360 div 15 - 1;
  with Image1.canvas do begin
    // C[W
    VRect := Rect(0, 0, Width, Height);
    Brush.Style := bsSolid;
    Brush.Color := clBlack;
    FillRect(VRect);                          // Canvas 摜
    Pen.Width :=2;
    // F}
    for i := 0 to N do begin
      // Fpx
      hu := i * q1 / 180 * pi;
      // FW B - Y
      cb := st * cos(hu);
      // FW R - Y
      cr := st * sin(hu);
      // R G B  ̒lvZ
      fr := y + cr;
      fg := y - kbg * cb - krg * cr;
      fb := y + cb;
      // őlŏl
      max := fr;
      min := fr;
      if fg > max then max := fg;
      if fb > max then max := fb;
      if fg < min then min := fg;
      if fb < min then min := fb;
      // R G B ̒lC
      ks := 255 / (max - min);
      r := round((fr - min) * ks);
      g := round((fg - min) * ks);
      b := round((fb - min) * ks);
      // `Fݒ
      Pen.Color := rgb(r, g, b);
      brush.Color := rgb(r, g, b);
      // F`
      Moveto(150 + round(80 * cos(i * q1p - q2p)),170 - round(80 * sin(i * q1p - q2p)));
      Lineto(150 + round(120 * cos(i * q1p - q2p)),170 - round(120 * sin(i * q1p - q2p)));
      AngleArc(150, 170, 120, i* q1 - q2, q2 * 2);

      Moveto(150 + round(80 * cos(i * q1p - q2p)),170 - round(80 * sin(i * q1p - q2p)));
      AngleArc(150, 170, 80,i* q1 - q2, q2 * 2);
      Lineto(150 + round(120 * cos(i * q1p + q2p)),170 - round(120 * sin(i * q1p + q2p)));
      // hԂ
      floodfill(150 + round(100 * cos(i * q1p)),170 - round(100 * sin(i * q1p)),rgb(r, g, b),fsBorder);
    end;
  end;
end;

procedure Tform1.color_barout(Mode, r, g, b, pich, dtop: integer; fColor: Tcolor);
var
  kr, kg, kb    : double;
  y, cb, cr     : double;
  hu            : double;
  color         : Tcolor;
  Vrect         : Trect;
begin
  if Mode = 0 then begin
    // WPxϊW@
    kr := 0.299;
    kg := 0.587;
    kb := 0.114;
  end
  else begin
    // `FbN PxϊWFpx120xɂȂ悤ɐݒ R 105x g 225x b 345x
    // R105xɂ
    kr := 255 / (255 - 255 * tan(105 / 180 * pi));  // kr = kb = 0.211325
    kb := kr;
    kg := 1 - kr - kb;                              // kg = 0.57735
  end;
  image1.Canvas.Font.Size := 11;
  y := kr * r + kg * g + kb * b;
  cr := r - y;
  cb := b - y;
  hu := arctan2(cr, cb) * 180 / pi;
  if hu < 0 then hu := hu + 360;
  color := rgb(r, g, b);
  Vrect := rect(330, Dtop + pich, 400, Dtop + 30 + pich);
  image1.Canvas.Pen.Color := color;
  image1.Canvas.Brush.Color := color;
  image1.Canvas.FillRect(Vrect);
  image1.Canvas.Font.Color := fColor;
  image1.Canvas.TextOut(345, Dtop+ 5 + pich, floattostrf(hu, ffFixed, 5, 1) + '');
end;

procedure Tform1.color_bar(Mode: integer);
var
  r, g, b       : integer;
begin
  r := 255;
  g := 0;
  b := 0;
  color_barout(Mode, r, g, b, 0, 100, clYellow);
  r := 0;
  g := 255;
  b := 0;
  color_barout(Mode, r, g, b, 30, 100, clBlack);
  r := 0;
  g := 0;
  b := 255;
  color_barout(Mode, r, g, b, 60, 100, clWhite);
end;

procedure Tform1.MonoColor_bar(Mode: integer);
var
  r, g, b :   Byte;
  ch      :   integer;
  fcolor  :   Tcolor;
  y       :   double;
begin
  val(RedEdit.Text, r, ch);
  if ch <> 0 then begin
    application.MessageBox('Ԃ̒lɃ~X܂', '', 0);
    exit;
  end;
  val(GreenEdit.Text, g, ch);
  if ch <> 0 then begin
    application.MessageBox('΂̒lɃ~X܂', '', 0);
    exit;
  end;
  val(BlueEdit.Text, b, ch);
  if ch <> 0 then begin
    application.MessageBox('̒lɃ~X܂', '', 0);
    exit;
  end;
  y := 0.299 * r + 0.587 * g + 0.114 * b;
  if y > 100 then fcolor := clBlack
             else fcolor := clWhite;
  color_barout(Mode, r, g, b, 0, 220, fcolor);
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  hue_circle(1);
  color_bar(1);
  MonoColor_bar(1);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  hue_circle(0);
  color_bar(0);
  MonoColor_bar(0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  RedEdit.Text   := '128';
  GreenEdit.Text := '128';
  BlueEdit.Text  := '128';
end;

end.
